#ifndef ATCAN_H
#define	ATCAN_H

//////////////////////////////////////////////////////////////////////////////
//
//							Message Formats
//
//////////////////////////////////////////////////////////////////////////////

typedef struct ATCANMSG									// Raw CAN message
	{
	UINT32	index;										// Message index
	UINT32	payload_lo,									// Raw data
			payload_hi;
	UINT8	msglen;										// Number of bytes in data[] to transmit
	UINT8	mailbox;									// Assigned mailbox
	} __attribute__((packed)) ATCANMSG;					// NOTE:  YOU MUST USE MEMCPY TO FILL THIS BLOCK DUE TO WORD ALIGNMENTS!

#define	ATCAN_SUCCESS				(1)					// CAN request succeeded
#define	ATCAN_FAILED				(0)					// CAN request failed

#define	ATCAN_MB_RX_0				(0)					// Receive mailbox 0
#define	ATCAN_MB_RX_1				(1)					// Receive mailbox 1
#define	ATCAN_MB_RX_2				(2)					// Receive mailbox 2
#define	ATCAN_MB_RX_3				(3)					// Receive mailbox 3
#define	ATCAN_MB_RX_4				(4)					// Receive mailbox 4
#define	ATCAN_MB_RX_5				(5)					// Receive mailbox 5
#define	ATCAN_MB_RX_6				(6)					// Receive mailbox 6
#define	ATCAN_MB_TRANSMIT			(7)					// Transmit mailbox

UINT8 atcan_put (ATCANMSG *msg);						// Queue message for transmission
UINT8 atcan_get (ATCANMSG *msg);						// Receive queued message
UINT32 atcan_instatus (void);							// Is there anything in the receive queue?
UINT32 atcan_outstatus (void);							// Is there room in the transmit queue?
void atcan_init (void);									// Initialize CAN interface

#endif

